"""
Программа Fpyprog, написана Ф.И.Беляловым с целью изучения Python
"""
#!/usr/bin/env python3
# -*- coding: utf-8 -*-
from tkinter import *
from tkinter import filedialog
import tkinter as tk
import tkinter.messagebox

from PIL import Image, ImageTk
import wx
import wx.grid as gridlib
import pickle
import os
import sys
import configparser

import sqlite3
import sqlite3 as sqlite
from xlrd import *
from matplotlib.backends.backend_tkagg import FigureCanvasTkAgg
import matplotlib.pyplot as plt
from mpl_toolkits import mplot3d

from numpy import *
import numpy as np
from statistics import mean, median
from scipy.stats import ttest_ind
from scipy.stats import spearmanr
from scipy.stats import pearsonr

"""
1. Если не запускается из командной строки, обычно не установлены библиотеки (в PyCharm свои экземпляры)
2. Чтобы запустить программу на другом компьютере установи Python и библиотеки.
3. Библиотеки в Python установить pip install wxpython/pandas/matplotlib через командную строку TC
из каталога Compiler/Python/Python37-32/Scripts/ (не видит, хотя прописано в PATH).
4. Если переименовать файл из *.py в *.pyw, то при запуске не будет вылазить пустая консоль 
"""

#arglob = [1,2,3,4,5,6] #Можно вместо файла хранить в глобальной переменной
isclear = False #глобальная переменная для очистки основного окна
vast = -999.0

def printlog(*args, **kwargs):
    print(*args, **kwargs)

    with open('output.txt', 'a') as file:
        print(*args, **kwargs, file=file)


class TextOut(tk.Text):
    #Устанавливает sys.stdout (вывод на консоль в Python) на экземпляр подкласса.
    def write(self, s):
        global isclear
        if isclear:
            self.delete('1.0', END)  #Очищаем
        else:
            self.insert('1.0', s)  #Пишем с первой строки

    def flush(self):
        pass

#------------------------
def fileopen():
    wind = Tk()
    wind.withdraw() #Скрываем пустое окно
    file_dir = os.path.dirname(os.path.abspath(__file__)) + '\data'
    wind.filename = filedialog.askopenfilename(initialdir=file_dir,title="Select file",filetypes=(("all files", "*.*"), ("sqlite files", "*.sqlite")))
    f = wind.filename
    file_name, file_extension = os.path.splitext(f)

    tempar = np.array([],dtype=float32)
    #SQLite
    if file_extension=='.sqlite' or file_extension=='.mb':
        conn = sqlite3.connect(f)
        cursor = conn.cursor()
        head, tail = os.path.split(f)  # tail - файл без пути

        # Get List of Tables:
        tableListQuery = "SELECT name FROM sqlite_master WHERE type='table' ORDER BY Name"
        cursor.execute(tableListQuery)
        tables = map(lambda t: t[0], cursor.fetchall())

        # Выбираем базу данных
        wind1 = Tk()
        wind1.title("Таблицы")
        wind1.resizable(False, False)
        w = wind1.winfo_screenwidth()  
        h = wind1.winfo_screenheight()  
        w = w // 2  
        h = h // 2
        w = w - 300  
        h = h - 50
        wind1.geometry('140x200+{}+{}'.format(w, h))

        listbox = Listbox(wind1)
        tablesToIgnore = ["sqlite_sequence"]
        for table in tables:
            if table in tablesToIgnore:
                continue
            listbox.insert(END, table)

        listbox.pack()

        def quit():
            wind1.withdraw()  # если вместо quit - destroy, то закрывается все
            wind1.quit()  # causes mainloop to exit.

        Button(wind1, text="Select table", command=quit).pack(expand=YES, fill=X)  # Иначе не выйти с выбором
        wind1.mainloop()
        tb0 = [listbox.get(idx) for idx in listbox.curselection()]
        tbl = ''.join(tb0)  # в string

        a = []
        logins = cursor.execute('select * from ' + tbl)
        ri = -1  # Иначе считывает нумерацию ключевого поля и переходит к соответствующей строке грида!!!
        for row in logins:
            a.append([])
            ri = ri + 1
            cells = row[1:]
            ncell = len(cells)
            for i in range(0, ncell):
                n = cells[i]
                #Проблема в том, что программа не знает, что пустое поле числовое
                #и пропускает его. Поэтому лучше вначале сделать файл данных из БД.
                if ((type(n) == int) or (type(n) == float)):
                    if ((n is None) or (n is "null")):
                        a[ri].append(-999)
                    else:
                        a[ri].append(cells[i])

        # преобразуем ряды и строки
        b = np.array(a)
        tempar = b.transpose()

    # Excel
    elif file_extension == '.xls' or file_extension == '.xlsx':
        """
        df = pd.read_excel('data.xlsx', sheet_name=0)
        print(df)        
        """
        a = []
        wb = open_workbook(f)
        s = wb.sheet_by_index(0)
        for col in range(s.ncols):
            values = []
            for row in range(s.nrows):
                c = s.cell(row, col).value
                if (type(c) == int) or (type(c) == float):
                    values.append(c)
            if len(values) > 0:  #если пустой ряд нечисловой []
                a.append(values)
        b = np.array(a)
        tempar = b
    else:
        #x, y, z = loadtxt(f, unpack=True)  #считывает в 3 массива float
        a = loadtxt(f)  #считывает в 2-мерный массив float
        b = np.array(a)

        #преобразуем ряды и строки
        tempar = b.transpose()

    #Выводит весь массив
    np.set_printoptions(threshold=sys.maxsize)
    global isclear
    isclear = False
    printlog()
    printlog(tempar)  #на консоль и в файл

    #сохраняем данные в своем формате и потом данные из файла используются для расчетов
    """
    Ранее было в другом типе файла
    with open('array.txt', 'wb') as fp:
        pickle.dump(tempar, fp)
    """
    np.save('array.npy', tempar)

# ------------------------
def fileopen1():
    file_dir = os.path.dirname(os.path.abspath(__file__))

    wind = Tk()
    wind.withdraw()  #Скрываем пустое окно
    wind.filename = filedialog.askopenfilename(initialdir=file_dir, title="Select file", filetypes=(("all files","*.*"), ("sqlite files","*.sqlite")))
    os.startfile(wind.filename)

# ------------------------
def deleteoutliers():
    a1 = np.load('array.npy')
    newa1 = a1
    nc = newa1.ndim+1
    nr = newa1.size//nc

    for i in range(nc):
        meangrade = newa1[i,:].mean()
        stdgrade = newa1[i,:].std()
        toprange = meangrade + stdgrade * 1.96
        botrange = meangrade - stdgrade * 1.96

        for j in range(nr):
            dat = newa1[i,j]
            if ((dat >= toprange) or (dat <= botrange)):
                newa1[i,j] = "{0:.2f}".format(meangrade)

    global isclear
    isclear = False
    printlog() #пустая строка
    printlog(newa1) #на консоль
    np.save('array.npy', newa1)

# ------------------------
def deletevast():
    a1 = np.load('array.npy')
    newa1 = a1
    nc = newa1.ndim+1
    nr = newa1.size//nc

    global vast
    vast1 = float(vast)
    for i in range(nc):
        meangrade = newa1[i,:].mean()
        for j in range(nr):
            dat = newa1[i,j]
            #math.isclose точнее, чем np.isclose
            if math.isclose(dat, vast1, rel_tol=1e-09, abs_tol=0.0):
                newa1[i,j] = "{0:.2f}".format(meangrade)

    global isclear
    isclear = False
    printlog() #пустая строка
    printlog(newa1) #на консоль
    np.save('array.npy', newa1)

# ------------------------
def datafileopen():
    a1 = np.load('array.npy')

    #Выводит весь массив
    np.set_printoptions(threshold=sys.maxsize)
    global isclear
    isclear = False
    printlog() #пустая строка
    printlog(a1) #на консоль


#==========================
class DataBase (wx.Frame):
    def __init__(self):
        wx.Frame.__init__(self, None, wx.ID_ANY,"База данных",size=(700,400))
        self.Centre()

        def SelecTable():
            # =====================================
            file_dir = os.path.dirname(os.path.abspath(__file__))+'\data'
            wind = Tk()
            wind.withdraw()  # Скрываем пустое окно
            wind.filename = filedialog.askopenfilename(initialdir=file_dir,
                                                       title="Select file",
                                                       filetypes=(("all files", "*.*"), ("sqlite files", "*.sqlite")))
            db = wind.filename
            file_name, file_extension = os.path.splitext(db)
            if file_extension == '.sqlite' or file_extension == '.mb':
                connection = sqlite.connect(db)
                cursor = connection.cursor()

                # Get List of Tables:
                tableListQuery = "SELECT name FROM sqlite_master WHERE type='table' ORDER BY Name"
                cursor.execute(tableListQuery)
                tables = map(lambda t: t[0], cursor.fetchall())

                # Выбираем базу данных
                wind1 = Tk()
                wind1.title("Таблицы")
                wind1.resizable(False, False)
                w = wind1.winfo_screenwidth()  
                h = wind1.winfo_screenheight()  
                w = w // 2  
                h = h // 2
                w = w - 300  
                h = h - 50
                wind1.geometry('140x200+{}+{}'.format(w, h))

                listbox = Listbox(wind1)

                tablesToIgnore = ["sqlite_sequence"]
                for table in tables:
                    if table in tablesToIgnore:
                        continue
                    listbox.insert(END, table)

                listbox.pack()
                def quit():
                    wind1.withdraw()  #если вместо quit - destroy, то закрывается все
                    wind1.quit()  #causes mainloop to exit.

                Button(wind1, text="Select table", command=quit).pack(expand=YES, fill=X) #Иначе не выйти с выбором
                wind1.mainloop()
                tb0 = [listbox.get(idx) for idx in listbox.curselection()]
                tbl = ''.join(tb0)  #в string
                str = db +"," + tbl #возвращает только одно значение
                return str

        def onLoadTable(self):
            self.grid.ClearGrid()
            #Названия полей
            metadata = self.cursor.execute('SELECT * from ' + tblname)
            labels = []
            for i in metadata.description:
                labels.append(i[0])  #Считывает названия полей
            labels = labels[1:]
            for i in range(len(labels)):
                self.grid.SetColLabelValue(i, labels[i])  #Записывает названия полей в грид

            # Данные
            logins = self.cursor.execute('SELECT * from ' + tblname)
            ri = 0  #Иначе считывает нумерацию ключевого поля и переходит к соответствующей строке грида!!!
            for row in logins:
                ri = ri+1
                cells = row[1:]
                for i in range(0, len(cells)):
                    if cells[i] is not None and cells[i] != "null":
                        self.grid.SetCellValue(ri-1, i, str(cells[i]))
            self.Show()
            self.db.commit()

        #===============class DataBase==========================
        panel = wx.Panel(self, -1)

        db0 = str(SelecTable())  #выбираем БД
        dba = db0.split(',')  #из строки - список, разделенный запятой
        db1 = dba[0]
        tblname = dba[1]

        db = sqlite3.connect(db1)
        self.db = db
        self.cursor = self.db.cursor()

        #Создаем пустой grid
        vbox = wx.BoxSizer(wx.VERTICAL)
        self.grid = wx.grid.Grid(panel)
        rows = self.cursor.execute('SELECT Count(*) FROM ' + tblname)
        val = rows.fetchone()

        #Число полей
        columnsQuery = "PRAGMA table_info(%s)" % tblname
        self.cursor.execute(columnsQuery)
        numberOfColumns = len(self.cursor.fetchall())-1

        self.db_exists = val[0]
        self.grid.CreateGrid(val[0],numberOfColumns)  #Ряды, столбцы
        self.grid.Scroll(0,0)
        vbox.Add(self.grid)
        panel.SetSizerAndFit(vbox)

        #Загружаем таблицу
        onLoadTable(self)

# ------------------------
def showdb():
    if __name__ == "__main__":
        app = wx.App()
        frame = DataBase()
        frame.Show()
        app.MainLoop()  #запускает основной бесконечный цикл

#------------------------
def dbinfo():
    file_dir = os.path.dirname(os.path.abspath( __file__ ))+'\data'

    wind = Tk()
    wind.withdraw() #Скрываем пустое окно
    wind.filename =  filedialog.askopenfilename(initialdir = file_dir,title = "Select file",filetypes = (("all files","*.*"), ("sqlite files","*.sqlite")))
    f = wind.filename
 
    connection = sqlite.connect(f)
    cursor = connection.cursor()

    tablesToIgnore = ["sqlite_sequence"]

    # Get List of Tables:
    tableListQuery = "SELECT name FROM sqlite_master WHERE type='table' ORDER BY Name"
    cursor.execute(tableListQuery)
    tables = map(lambda t: t[0], cursor.fetchall())

    global isclear
    isclear = False
    printlog()  # пустая строка
    for table in tables:
        if table in tablesToIgnore:
            continue

        columnsQuery = "PRAGMA table_info(%s)" % table
        cursor.execute(columnsQuery)
        numberOfColumns = len(cursor.fetchall())

        rowsQuery = "SELECT Count() FROM %s" % table
        cursor.execute(rowsQuery)
        numberOfRows = cursor.fetchone()[0]

        #%d is the formatting option for signed decimal integers, and %s is for strings
        printlog("%s\t\t%d\t\t%d" % (table, numberOfColumns, numberOfRows))

    printlog("TableName\t\tColumns\t\tRows") #\t is used for TAB character
    cursor.close()
    connection.close()

    wind.mainloop()

#========================
def curarray():
    sa = np.load('array.npy')

    #Выводит весь массив
    np.set_printoptions(threshold=sys.maxsize)
    global isclear
    isclear = False
    printlog()  # пустая строка
    printlog(sa)

# ---------Выбираем переменные------------
def currvar(numcols1, one, nmbselect):
    wind = Tk()
    ns0 = "Выбор N "+ nmbselect
    wind.title(ns0)
    wind.resizable(False, False)
    w = wind.winfo_screenwidth()
    h = wind.winfo_screenheight()
    w = w // 2
    h = h // 2
    w = w - 300
    h = h - 50
    wind.geometry('140x200+{}+{}'.format(w, h))

    if one:
        lb = Listbox(wind, selectmode=SINGLE)  # create Listbox
    else:
        lb = Listbox(wind, selectmode=MULTIPLE, exportselection=0)

    for n in range(numcols1):
        vr = 'var_'+str(n)
        lb.insert(END, vr)  # put nums 0-4 in listbox
    lb.pack()  # put listbox on window

    def quit():
        wind.withdraw()
        wind.quit()  # causes mainloop to exit.

    ns = "Select " + nmbselect +" var"
    Button(wind, text=ns, command=quit).pack(expand=YES, fill=X)  # Иначе не выйти с выбором
    wind.mainloop()

    cnmb = lb.curselection()  #список выбора (0, 2, 4...)
    return cnmb

# ------------------------
def statistics():
    """
    #Ранее было в другом типе файла
    with open('array.txt', 'rb') as fp:
        sa = pickle.load(fp)  #массив
    a1 = np.array(sa)  #переводит list в array
    """
    a1 = np.load('array.npy')
    numcols = len(a1)

    clnmb = currvar(numcols, True, "1") #окно выбора переменных
    a = a1[clnmb[0],:]  #выбирает 1 столбец
    len1 = len(a)
    result = ' Число значений: ' + str(len1)

    av = mean(a)
    av1 = "{0:.2f}".format(av)
    result1 = ' Среднее: ' + str(av1)

    md = median(a)
    md2 = "{0:.2f}".format(md)
    result2 = ' Медиана: ' + str(md2)

    sd = std(a)
    sd1 = "{0:.2f}".format(sd)
    result3 = ' Стандартное отклонение: ' + str(sd1)

    max1 = max(a)
    max2 = "{0:.2f}".format(max1)
    result4 = ' Максимум: ' + str(max2)

    min1 = min(a)
    min2 = "{0:.2f}".format(min1)
    result5 = ' Минимум: ' + str(min2)

    suma = sum(a)
    suma1 = "{0:.2f}".format(suma)
    result6 = ' Сумма: ' + str(suma1)

    global isclear
    isclear = False
    resultfull = result+'\n'+result1+'\n'+result2+'\n'+result3+'\n'+result4+'\n'+result5+'\n'+result6
    printlog()
    printlog(resultfull)


# ------------------------
def pearson():
    a1 = np.load('array.npy')
    numcols = len(a1)

    clnmb = currvar(numcols, False, "2")  # окно выбора переменных
    nc = len(clnmb)
    if nc == 2:
        corr, p_value = pearsonr(a1[clnmb[0], :], a1[clnmb[1], :])

        cf = "{0:.2f}".format(corr)
        p = "{0:.3f}".format(p_value)

        result = ' Коэффициент Pearson: ' + str(cf)
        result1 = ' p: ' + str(p)

        resultfull = result + '\n' + result1

        global isclear
        isclear = False
        printlog()  # пустая строка
        printlog(resultfull)

# ------------------------
def spearmen():
    a1 = np.load('array.npy')
    numcols = len(a1)

    clnmb = currvar(numcols, False, "2") #окно выбора переменных
    nc = len(clnmb)
    if nc == 2:
        corr, p_value = spearmanr(a1[clnmb[0],:], a1[clnmb[1],:])

        cf = "{0:.2f}".format(corr)
        p = "{0:.3f}".format(p_value)

        result = ' Коэффициент Spearman: ' + str(cf)
        result1 = ' p: ' + str(p)

        resultfull = result+'\n'+result1

        global isclear
        isclear = False
        printlog() #пустая строка
        printlog(resultfull)

# ------------------------
def student():
    a1 = np.load('array.npy')
    numcols = len(a1)

    clnmb = currvar(numcols, False, "2") #окно выбора переменных
    nc = len(clnmb)
    if nc == 2:
        corr, p_value = ttest_ind(a1[clnmb[0],:], a1[clnmb[1],:])

        cf = "{0:.2f}".format(corr)
        p = "{0:.3f}".format(p_value)

        result = ' t-тест Student: ' + str(cf)
        result1 = ' p: ' + str(p)

        resultfull = result + '\n' + result1

        global isclear
        isclear = False
        printlog()  # пустая строка
        printlog(resultfull)

# ===========================
def gr_hystogr():
    a1 = np.load('array.npy')
    numcols = len(a1)

    clnmb = currvar(numcols, False, "1-4") #окно выбора переменных
    nc = len(clnmb)

    wind1 = tk.Tk()
    wind1.title("Гистограмма")
    wind1.resizable(False, False)

    w = wind1.winfo_screenwidth()
    h = wind1.winfo_screenheight()
    w = w // 2
    h = h // 2
    w = w - 380
    h = h - 220
    wind1.geometry('630x520+{}+{}'.format(w, h))


    fig1 = plt.figure()
    plt.clf()  # Очистка, иначе может нарисовать другой график

    if nc>1: #4 графика одновременно
        for n in range(nc):
            if n==0:
                ax1 = fig1.add_subplot(221)
                ax1.hist(a1[clnmb[n],:], 10)
            elif n==1:
                ax2 = fig1.add_subplot(222, sharex=ax1, sharey=ax1)
                ax2.hist(a1[clnmb[n],:], 10)
            elif n==2:
                ax3 = fig1.add_subplot(223, sharex=ax1, sharey=ax1)
                ax3.hist(a1[clnmb[n],:], 10)
            elif n==3:
                ax4 = fig1.add_subplot(224, sharex=ax1, sharey=ax1)
                ax4.hist(a1[clnmb[n],:], 10)
            else:
                pass
    elif nc==1: #1 график на все окно
        plt.style.use('ggplot')
        plt.xlabel('Интервалы значений')
        plt.ylabel('Число значений')
        plt.grid(axis='y', alpha=0.75)
        plt.hist(a1[clnmb[0],:], 10)
    else:
        pass

    canvas1 = FigureCanvasTkAgg(fig1, master=wind1)
    plot_widget1 = canvas1.get_tk_widget()
    plot_widget1.grid(row=0, column=0)

    #fig1.savefig('fgraph1.png')
    plt.close("all")

    wind1.mainloop()

#------------------------
def gr_scatter():
    a1 = np.load('array.npy')
    numcols = len(a1)

    clnmb = currvar(numcols, False, "2") #окно выбора переменных
    nc = len(clnmb)
    if nc == 2:
        wind2 = tk.Tk()
        wind2.title("Скатерограмма")
        wind2.resizable(False, False)

        w = wind2.winfo_screenwidth()
        h = wind2.winfo_screenheight()
        w = w // 2
        h = h // 2
        w = w - 380
        h = h - 220
        wind2.geometry('630x520+{}+{}'.format(w, h))

        fig2 = plt.figure() #пустое окно для графиков
        plt.clf() #Очистка, иначе может нарисовать другой график
        #plt.ion() #Интерактивный режим
        plt.style.use('ggplot')
        plt.xlabel('Переменная 1')
        plt.ylabel('Переменная 2')
        plt.grid(axis='y', alpha=0.75)
        plt.scatter(a1[clnmb[0], :], a1[clnmb[1], :])

        canvas2 = FigureCanvasTkAgg(fig2, master=wind2)
        plot_widget2 = canvas2.get_tk_widget()
        plot_widget2.grid(row=0, column=0)

        #fig2.savefig('fgraph2.png')
        plt.close("all")

        wind2.mainloop()

#------------------------
def gr_scatter3d():
    a1 = np.load('array.npy')
    numcols = len(a1)

    clnmb = currvar(numcols, False, "3") #окно выбора переменных
    nc = len(clnmb)
    if nc == 3:
        wind3 = tk.Tk()
        wind3.title("Скатерограмма 3D")
        wind3.resizable(False, False)
        w = wind3.winfo_screenwidth()
        h = wind3.winfo_screenheight()
        w = w // 2
        h = h // 2
        w = w - 380
        h = h - 220
        wind3.geometry('630x520+{}+{}'.format(w, h))

        fig3 = plt.figure() #пустое окно для графиков
        ax = plt.axes(projection='3d')
        ax.scatter3D(a1[clnmb[0],:], a1[clnmb[1],:], a1[clnmb[2],:], c=a1[clnmb[2],:], cmap='Greens')

        canvas3 = FigureCanvasTkAgg(fig3, master=wind3)
        plot_widget2 = canvas3.get_tk_widget()
        plot_widget2.grid(row=0, column=0)

        #fig3.savefig('fgraph3.png')
        plt.close("all")

        wind3.mainloop()

#=========================
def gr_series():
    a1 = np.load('array.npy')
    numcols = len(a1)

    clnmb = currvar(numcols, False, "1-4") #окно выбора переменных
    nc = len(clnmb)

    wind4 = tk.Tk()
    wind4.title("Временной ряд")
    wind4.resizable(False, False)
    w = wind4.winfo_screenwidth()
    h = wind4.winfo_screenheight()
    w = w // 2
    h = h // 2
    w = w - 380
    h = h - 220
    wind4.geometry('630x520+{}+{}'.format(w, h))

    fig = plt.figure()
    plt.clf()  # Очистка, иначе может нарисовать другой график

    if nc>1: #4 графика одновременно
        for n in range(nc):
            if n==0:
                ax1 = fig.add_subplot(221)
                ax1.plot(range(1, len(a1[clnmb[n], :]) + 1), a1[clnmb[n], :])
            elif n==1:
                ax2 = fig.add_subplot(222, sharex=ax1, sharey=ax1)
                ax2.plot(range(1, len(a1[clnmb[n], :]) + 1), a1[clnmb[n], :])
            elif n==2:
                ax3 = fig.add_subplot(223, sharex=ax1, sharey=ax1)
                ax3.plot(range(1, len(a1[clnmb[n], :]) + 1), a1[clnmb[n], :])
            elif n==3:
                ax4 = fig.add_subplot(224, sharex=ax1, sharey=ax1)
                ax4.plot(range(1, len(a1[clnmb[n], :]) + 1), a1[clnmb[n], :])
            else:
                pass
    elif nc==1: #1 график на все окно
        plt.style.use('ggplot')
        plt.xlabel('Последовательность')
        plt.ylabel('Переменная')
        plt.plot(range(1, len(a1[clnmb[0],:]) + 1), a1[clnmb[0],:])
    else:
        pass

    canvas4 = FigureCanvasTkAgg(fig, master=wind4)
    plot_widget4 = canvas4.get_tk_widget()
    plot_widget4.grid(row=0, column=0)

    # fig4.savefig('fgraph4.png')
    plt.close("all")

    wind4.mainloop()

#------------------------
def about():
    wind = tk.Tk()
    wind.title("FPyprog")
    wind.resizable(False, False)

    w = wind.winfo_screenwidth()  
    h = wind.winfo_screenheight()  
    w = w // 2  
    h = h // 2
    w = w - 300  
    h = h - 50
    wind.geometry('220x115+{}+{}'.format(w, h))

    st1 = '\nFPyprog'
    tk.Label(wind, text=st1, fg='dark green', font = "Arial 14 bold").pack()
    tk.Label(wind, text='Версия 1.04', fg='black', font = "Arial 11").pack()
    tk.Label(wind, text='(С) Белялов Ф.И., 2019', fg='black', font = "Arial 9").pack()
    wind.mainloop()

#------------------------
def helpfile():
    wind = tk.Tk()
    wind.title("Описание FPyprog")
    wind.resizable(False, False)

    w = wind.winfo_screenwidth()  
    h = wind.winfo_screenheight()  
    w = w // 2  
    h = h // 2
    w = w - 300  
    h = h - 50
    wind.geometry('440x340+{}+{}'.format(w, h))

    with open('readme.txt', 'r', encoding='utf-8') as myfile:
        data = myfile.read()

    Results = Label(wind, text=data, wraplength=420, justify=tk.LEFT)
    Results.pack(side=LEFT, fill=X)

    wind.mainloop()

#------------------------
def config():
    def quit():
        wind.withdraw()
        wind.quit()  # causes mainloop to exit.

    wind = Tk()
    wind.title("Настройки")
    wind.resizable(False, False)
    w = wind.winfo_screenwidth()
    h = wind.winfo_screenheight()
    w = w // 2
    h = h // 2
    w = w - 300
    h = h - 50
    wind.geometry('350x200+{}+{}'.format(w, h))

     #Размещение с помощью системы .grid, а не .pack(side=LEFT, expand=YES, fill=BOTH), где создается Frame для ряда
    file_dir = os.path.dirname(os.path.abspath(__file__))
    progpath = file_dir
    config = configparser.ConfigParser()
    cfgfile = progpath + '\Fpyprog.ini'
    config.read(cfgfile)

    #читаем из файла конфигурации
    prgcat = config.get('main', 'progcatalog')
    datcat = config.get('main', 'datacatalog')
    svfile = config.get('main', 'savefile')
    global vast
    vast = config.get('main', 'vast')

    #sticky = W for the Label, sticky = E for the Entry
    Label(wind, text="Каталог программы", justify=tk.LEFT).grid(row=0, sticky = W)
    ent = tk.Entry(wind, width=57)
    ent.grid(row=1)
    ent.insert(10, prgcat)

    Label(wind, text="Каталог данных", justify=tk.LEFT).grid(row=2, sticky = W)
    ent1 = tk.Entry(wind, width=57)
    ent1.grid(row=3)
    ent1.insert(10, datcat)

    Label(wind, text="Пустые заначения", justify=tk.LEFT).grid(row=4, sticky = W)
    ent2 = tk.Entry(wind, width=57)
    ent2.grid(row=5)
    ent2.insert(10, vast)

    #если делать не во фрейме с self.var.get(), то Checkbutton, в отличие от Entry не работает!
    var = IntVar()
    chk1 = tk.Checkbutton(wind, text="Сохранение в файле", variable=var)
    chk1.grid(row=6, sticky = W)

    Label(wind, text="").grid(row=7)
    Button(wind, text="Ввод данных", command=quit).grid(row=8)

    wind.mainloop()

    svfile = str(var.get())
    config.read(cfgfile)
    config.set('main', 'progcatalog', ent.get())
    config.set('main', 'datacatalog', ent1.get())
    config.set('main', 'savefile', svfile)
    config.set('main', 'vast', ent2.get())

    with open(cfgfile, 'w') as f:
        config.write(f)


# ------------------------
def clearout():
    global isclear
    answer = tkinter.messagebox.askquestion('Clear output file', 'Do you want clear past calculation?')
    if answer == 'yes':
        open('output.txt', 'w').close() #Очистить файл вывода данных
        isclear = True
        printlog()
    else:
        pass

#------------------------
def close_prog():
    sys.exit()

#=========================
class MenuToolbar(Frame):
    def __init__(self, parent):
        Frame.__init__(self, parent)
        self.parent = parent
        self.initui()

    def initui(self):
        menubar = Menu(self.parent)
        filemenu = Menu(menubar, tearoff=0)
        filemenu.add_command(label="Open data file", command=fileopen)
        filemenu.add_command(label="Open any file", command=fileopen1)
        filemenu.add_separator()
        filemenu.add_command(label="Exit", command=close_prog)
        menubar.add_cascade(label="File", menu=filemenu)

        datamenu = Menu(menubar, tearoff=0)
        datamenu.add_command(label="Open saved data", command=datafileopen)
        datamenu.add_command(label="Removing outliers", command=deleteoutliers)
        datamenu.add_command(label="Removing missing data", command=deletevast)
        datamenu.add_command(label="Clear output", command=clearout)
        menubar.add_cascade(label="Data", menu=datamenu)

        editmenu = Menu(menubar, tearoff=0)
        editmenu.add_command(label="DB infomation", command=dbinfo)
        editmenu.add_command(label="Show DB", command=showdb)
        menubar.add_cascade(label="DataBase", menu=editmenu)

        statmenu = Menu(menubar, tearoff=0)
        statmenu.add_command(label="Statistics", command=statistics)
        statmenu.add_command(label="Correlation Pearson ", command=pearson)
        statmenu.add_command(label="Correlation Spearman", command=spearmen)
        statmenu.add_command(label="t-test Student", command=student)
        statmenu.add_separator()
        statmenu.add_command(label="Current array", command=curarray)
        menubar.add_cascade(label="Calculation", menu=statmenu)

        grmenu = Menu(menubar, tearoff=0)
        grmenu.add_command(label="Hystogram", command=gr_hystogr)
        grmenu.add_command(label="Scatter plot", command=gr_scatter)
        grmenu.add_command(label="Series", command=gr_series)
        grmenu.add_command(label="Scatter 3D plot", command=gr_scatter3d)
        menubar.add_cascade(label="Graph", menu=grmenu)

        helpmenu = Menu(menubar, tearoff=0)
        helpmenu.add_command(label="Guide", command=helpfile)
        helpmenu.add_command(label="Config", command=config)
        helpmenu.add_command(label="About...", command=about)
        menubar.add_cascade(label="Tools", menu=helpmenu)

        #-----------------------
        toolbar = Frame(self.parent, bd=1, relief=RAISED)
        self.img1 = Image.open("pic/folder.png")
        eimg1 = ImageTk.PhotoImage(self.img1)
        openbutton = Button(toolbar, image=eimg1, relief=FLAT, command=fileopen)
        openbutton.image = eimg1
        openbutton.pack(side=LEFT, padx=2, pady=2)

        self.img2 = Image.open("pic/array.png")
        eimg2 = ImageTk.PhotoImage(self.img2)
        arbutton = Button(toolbar, image=eimg2, relief=FLAT, command=curarray)
        arbutton.image = eimg2
        arbutton.pack(side=LEFT, padx=2, pady=2)

        self.img3 = Image.open("pic/calculatefull.png")
        eimg3 = ImageTk.PhotoImage(self.img3)
        statbutton = Button(toolbar, image=eimg3, relief=FLAT, command=statistics)
        statbutton.image = eimg3
        statbutton.pack(side=LEFT, padx=2, pady=2)

        self.img4 = Image.open("pic/graph.png")
        eimg4 = ImageTk.PhotoImage(self.img4)
        grbutton = Button(toolbar, image=eimg4, relief=FLAT, command=gr_hystogr)
        grbutton.image = eimg4
        grbutton.pack(side=LEFT, padx=2, pady=2)

        self.img5 = Image.open("pic/exit.png")
        eimg5 = ImageTk.PhotoImage(self.img5)
        exitbutton = Button(toolbar, image=eimg5, relief=FLAT, command=close_prog)
        exitbutton.image = eimg5
        exitbutton.pack(side=LEFT, padx=2, pady=2)

        toolbar.pack(side=TOP, fill=X)
        self.parent.config(menu=menubar)
        self.pack()

    def onExit(self):
        self.quit()

def main():
    windmain = Tk() #Создаем корневое окно
    windmain.title("FPyprog 1.04")
    windmain.resizable(True, True)
    w = windmain.winfo_screenwidth()  
    h = windmain.winfo_screenheight()  
    w = w // 2  
    h = h // 2
    w = w - 450 
    h = h - 200
    windmain.geometry('600x400+{}+{}'.format(w, h))

    app = MenuToolbar(windmain)
    text = TextOut(windmain)
    sys.stdout = text
    text.pack(expand=True, fill=tk.BOTH)

    #считываем из файла конфиргурации
    progpath = os.path.dirname(os.path.abspath(__file__))
    config = configparser.ConfigParser()
    cfgfile = progpath + '\Fpyprog.ini'
    config.read(cfgfile)
    global vast  #Пропуски
    vast = config.get('main', 'vast')

    windmain.mainloop()

if __name__ == '__main__':
    main()
